#!/usr/local/bin/python

import getopt
import shutil
import subprocess
import sys


def transcode(src, tgt, fmt):
	transcode_opts = [ "ffmpeg" ];
	#transcode_opts.extend(["-t", "60"]) # testing only: only 60 seconds
	transcode_opts.extend(["-loglevel", "error"])
	transcode_opts.extend(["-i", src])

	#transcode_opts.extend(["-acodec", "libfaac"])
	transcode_opts.extend(["-ac", "2", "-ab", "128k"])
	transcode_opts.extend(["-vcodec", "libx264"])
	transcode_opts.extend(["-tune", "film", "-profile", "main"])
	if fmt == "hd":
		transcode_opts.extend(["-s",  "1280x720"])
		transcode_opts.extend(["-threads", "0", "-b", "4000k"])
	else:
		transcode_opts.extend(["-threads", "0", "-b", "900k", "-bt", "900k"])
		if str(fmt) == "43":
			pass
		elif str(fmt) == "149":
			transcode_opts.extend(["-vf", "crop=640:412"])
			transcode_opts.extend(["-aspect",  "14:9"])
		else:
			transcode_opts.extend(["-vf", "crop=640:360"])
			transcode_opts.extend(["-aspect",  "16:9"])
		transcode_opts.extend(["-y", "-deinterlace", "-vsync", "1"])
	transcode_opts.append(tgt)

	print "    %s" % " ".join(transcode_opts)
	subprocess.check_call(transcode_opts)


class Usage(Exception):
	def __init__(self, msg):
		self.msg = msg;
	def __str__(self):
		return repr(self.msg)


def main(argv=None):
	if argv is None:
		argv = sys.argv
   	try:
   		try:
			opts, args = getopt.getopt(argv[1:], "h", ["help"])
		except getopt.error, msg:
			raise Usage(msg)
		for (o, v) in opts:
			if o == "-h":
				print >>sys.stderr, "help text"
				return 0
		if len(args) != 3:
			raise Usage("wrong number of arguments")
		transcode(args[1], args[2], args[0])
	except Usage, err:
		print >>sys.stderr, err.msg
		print >>sys.stderr, "tivomp4 format source destination"
		print >>sys.stderr, "for help use --help"
		return 64
                                                                                             
if __name__ == "__main__":
	sys.exit(main())
